#!/bin/bash

# Generate PHP code for the competition web site to print tool names with links to the project web site.

echo "<?php
";

CATEGORY_STRUCTURE="benchmark-defs/category-structure.yml"
YEAR=$(yq --raw-output '.year' "$CATEGORY_STRUCTURE")
COMPETITIONNAME=$(yq --raw-output '.competition' "$CATEGORY_STRUCTURE")

echo "# This is generated by $0. Do not change manually.";

ls -1 ./fm-tools/data/*.yml \
| grep -v "schema.yml" \
| xargs --replace=ARG yq -r '["ARG", .name, .project_url] | join(";")' ARG \
| while IFS=';' read TOOLFILE TOOLNAME TOOLURL; do
  TOOL=$(basename ${TOOLFILE%.yml})
  TOOLFUNC=${TOOL//[2]/two}
  TOOLFUNC=${TOOLFUNC//\-/}
  echo "function ${TOOLFUNC,,}${YEAR}() {";
  if [ -n "$TOOLURL" ]; then
    echo "  echo '<a href=\"$TOOLURL\">$TOOLNAME</a>';";
  else
    echo "  echo '$TOOLNAME';";
  fi
  echo "}";
  echo "";
done

echo "
?>";
